<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOfferByReductionPrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfOfferByReductionPrice extends AbstractStructArrayBase
{
    /**
     * The OfferByReductionPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OfferByReductionPrice[]
     */
    public $OfferByReductionPrice;
    /**
     * Constructor method for ArrayOfOfferByReductionPrice
     * @uses ArrayOfOfferByReductionPrice::setOfferByReductionPrice()
     * @param \StructType\OfferByReductionPrice[] $offerByReductionPrice
     */
    public function __construct(array $offerByReductionPrice = array())
    {
        $this
            ->setOfferByReductionPrice($offerByReductionPrice);
    }
    /**
     * Get OfferByReductionPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OfferByReductionPrice[]|null
     */
    public function getOfferByReductionPrice()
    {
        return isset($this->OfferByReductionPrice) ? $this->OfferByReductionPrice : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOfferByReductionPrice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOfferByReductionPrice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOfferByReductionPriceForArrayConstraintsFromSetOfferByReductionPrice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOfferByReductionPriceOfferByReductionPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfOfferByReductionPriceOfferByReductionPriceItem instanceof \StructType\OfferByReductionPrice) {
                $invalidValues[] = is_object($arrayOfOfferByReductionPriceOfferByReductionPriceItem) ? get_class($arrayOfOfferByReductionPriceOfferByReductionPriceItem) : sprintf('%s(%s)', gettype($arrayOfOfferByReductionPriceOfferByReductionPriceItem), var_export($arrayOfOfferByReductionPriceOfferByReductionPriceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OfferByReductionPrice property can only contain items of type \StructType\OfferByReductionPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OfferByReductionPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OfferByReductionPrice[] $offerByReductionPrice
     * @return \ArrayType\ArrayOfOfferByReductionPrice
     */
    public function setOfferByReductionPrice(array $offerByReductionPrice = array())
    {
        // validation for constraint: array
        if ('' !== ($offerByReductionPriceArrayErrorMessage = self::validateOfferByReductionPriceForArrayConstraintsFromSetOfferByReductionPrice($offerByReductionPrice))) {
            throw new \InvalidArgumentException($offerByReductionPriceArrayErrorMessage, __LINE__);
        }
        if (is_null($offerByReductionPrice) || (is_array($offerByReductionPrice) && empty($offerByReductionPrice))) {
            unset($this->OfferByReductionPrice);
        } else {
            $this->OfferByReductionPrice = $offerByReductionPrice;
        }
        return $this;
    }
    /**
     * Add item to OfferByReductionPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\OfferByReductionPrice $item
     * @return \ArrayType\ArrayOfOfferByReductionPrice
     */
    public function addToOfferByReductionPrice(\StructType\OfferByReductionPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OfferByReductionPrice) {
            throw new \InvalidArgumentException(sprintf('The OfferByReductionPrice property can only contain items of type \StructType\OfferByReductionPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OfferByReductionPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OfferByReductionPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OfferByReductionPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OfferByReductionPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OfferByReductionPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OfferByReductionPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OfferByReductionPrice
     */
    public function getAttributeName()
    {
        return 'OfferByReductionPrice';
    }
}
